<template>
  <div>
    <v-row align="center">
      <v-col cols="2"></v-col>
      <v-col cols="8" align="center">
        <v-progress-linear
          color="primary"
          rounded
          :value="experimentStatus"
          stream
        >
        </v-progress-linear>
        <p>Experiments done: {{ current_loop }}/{{ target_loops }}</p>
      </v-col>
      <v-col cols="2"></v-col>
    </v-row>
    <v-row align="center">
      <v-col cols="5" align="center">
        <Coms />
      </v-col>
      <v-col cols="2" align="center">
        <Connector class="mb-10" />

        <v-btn color="primary" :disabled="!canGoBack" @click="emitGoBack"
          ><v-icon left>mdi-chevron-left</v-icon>Back</v-btn
        >
      </v-col>
      <v-col cols="5" align="center">
        <Timer v-if="$store.getters['settings/timer'].timer" />
        <br />
        <p class="subtitle-1">
          {{ actionMessage }}
          <v-progress-circular
            class="pl-10"
            v-if="action_code > -1"
            size="20"
            :color="actionColor"
            indeterminate
          />
        </p>
        <p class="message">{{ message }}</p>
      </v-col>
    </v-row>
    <Post :loops_done="current_loop" :target="target_loops"/>
  </div>
</template>

<script>
import Coms from "./Tab3/Coms";
import Timer from "./Tab3/Timer";
import Connector from "./Tab3/Connector";
import { Action } from "@/plugins/data_structures/Enums";

import Post from "./Tab3/Post";

export default {
  name: "Tab3",
  components: {
    Coms,
    Connector,
    Timer,
    Post
  },
  data: () => ({
    ack: false,
    synack: false,
    handshake: false,
    message: "Board disconnected",
    action_code: Action.UNKNOWN,
  }),
  computed: {
    canGoBack() {
      return !this.$store.getters["status/isConnected"];
    },
    actionMessage() {
      switch (this.action_code) {
        case Action.UNKNOWN:
          return "Disconnected";
        case Action.STANDBY:
          return "Connecting";
        case Action.LOGGING:
          return "Logging";
        case Action.ERROR:
          return "Error";
        case Action.REQ_PARAM:
          return "Requesting parameter";
        default:
          return "Internal error, check the console";
      }
    },
    actionColor() {
      switch (this.action_code) {
        case Action.UNKNOWN:
          return null;
        case Action.STANDBY:
          return "primary";
        case Action.LOGGING:
          return "success";
        case Action.ERROR:
          return "error";
        case Action.REQ_PARAM:
          return "warning";
        default:
          return "Internal error, check the console";
      }
    },
    experimentStatus() {
      return 100 * (this.current_loop / this.target_loops);
    },
    current_loop() {
      return this.$store.getters["status/experiment_current_loop"];
    },
    target_loops() {
      return this.$store.getters["status/experiment_loops"];
    },
  },
  methods: {
    emitGoBack() {
      this.$emit("goBack");
    },
  },
  mounted() {
    this.$socket.on("board-status", (data) => {
      this.handshake = data.handshake;
      this.synack = data.synack;
      this.ack = data.ack;
      this.message = data.message;
      this.action_code = parseInt(data.action);
      this.$store.dispatch("status/setSerialStats", {
        logssec: data.logss,
      });
    });
  },
};
</script>

<style scoped>
.message {
  font-style: italic;
}
</style>